
#line 3 "lexer.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 35
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart(yyin  )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

extern int yyleng;

extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    /* Note: We specifically omit the test for yy_rule_can_match_eol because it requires
     *       access to the local variable yy_act. Since yyless() is a macro, it would break
     *       existing scanners that call yyless() from OUTSIDE yylex. 
     *       One obvious solution it to make yy_act a global. I tried that, and saw
     *       a 5% performance hit in a non-yylineno scanner, because yy_act is
     *       normally declared as a register variable-- so it is not worth it.
     */
    #define  YY_LESS_LINENO(n) \
            do { \
                int yyl;\
                for ( yyl = n; yyl < yyleng; ++yyl )\
                    if ( yytext[yyl] == '\n' )\
                        --yylineno;\
            }while(0)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = 0; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart (FILE *input_file  );
void yy_switch_to_buffer (YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer (FILE *file,int size  );
void yy_delete_buffer (YY_BUFFER_STATE b  );
void yy_flush_buffer (YY_BUFFER_STATE b  );
void yypush_buffer_state (YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state (void );

static void yyensure_buffer_stack (void );
static void yy_load_buffer_state (void );
static void yy_init_buffer (YY_BUFFER_STATE b,FILE *file  );

#define YY_FLUSH_BUFFER yy_flush_buffer(YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer (char *base,yy_size_t size  );
YY_BUFFER_STATE yy_scan_string (yyconst char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes (yyconst char *bytes,int len  );

void *yyalloc (yy_size_t  );
void *yyrealloc (void *,yy_size_t  );
void yyfree (void *  );

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define yywrap(n) 1
#define YY_SKIP_YYWRAP

typedef unsigned char YY_CHAR;

FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;

typedef int yy_state_type;

extern int yylineno;

int yylineno = 1;

extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state (void );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  );
static int yy_get_next_buffer (void );
static void yy_fatal_error (yyconst char msg[]  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	yyleng = (size_t) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;

#define YY_NUM_RULES 97
#define YY_END_OF_BUFFER 98
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_accept[443] =
    {   0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,   98,   96,   95,   95,   96,   96,
       96,   42,   68,   96,   96,   96,   96,   73,   96,   73,
       73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
       43,   44,   67,   95,   68,   96,   96,   96,   73,   73,
       73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
       88,   87,   87,   88,   88,   74,   76,   88,   79,   75,
       77,   78,   85,   85,   85,   55,   55,   54,   53,   52,
       40,   39,   39,   40,   38,   36,   36,   38,   38,   38,
       11,   13,   38,   17,   18,    9,   12,    8,   14,   10,

       32,   32,    3,   24,    7,   25,   37,   37,   37,   37,
       37,   37,   37,   15,   16,    0,    0,   94,    0,    0,
       72,   72,   72,   70,   81,   73,    0,   73,   73,   73,
       73,   73,    1,   73,   73,   73,   73,   73,   73,   73,
       73,    0,    0,    0,    0,    0,    0,    0,    0,   72,
        0,    0,    0,   73,   73,   73,   73,   73,   73,   73,
       73,    1,   73,   73,   73,   73,   73,   73,   73,   73,
        0,   80,    0,    0,   86,   82,   75,   85,   85,   84,
       56,   52,   41,   22,    0,   35,    0,    0,   33,    0,
       34,    0,   83,   30,    0,   32,   20,   23,   19,   21,

       37,   37,   37,   37,    4,   37,   37,    0,   90,    0,
       89,    0,    0,   92,    0,   72,   72,   69,   69,   70,
       71,   73,   73,   73,   73,   73,   73,   73,   73,   73,
       73,   48,   73,   73,   73,   66,    0,   93,   72,    0,
        0,   66,   73,   73,   73,   73,   73,   73,   73,   73,
       73,   73,   48,   73,   73,   73,    0,    0,    0,   33,
        0,    0,   31,    5,   37,    6,   37,   37,    0,   91,
       72,   69,   69,   71,   73,   47,   73,   73,   46,   73,
       73,   73,   73,   73,   73,   45,   73,   73,    0,    0,
        0,   73,   47,   73,   73,   46,   73,   73,   73,   73,

       73,   73,   45,   73,   73,    0,    0,    0,    0,    0,
       37,   37,    2,   73,   73,   73,   73,   73,   73,   73,
       73,   73,   73,   49,    0,    0,   73,   73,   73,   73,
       73,   73,   73,   73,   73,   73,   49,    0,   37,   37,
       73,   73,   73,   73,    0,   62,   73,   73,   73,   73,
       73,    0,    0,   73,   73,   73,   73,   73,   73,   73,
       73,   73,   37,   37,    0,   64,   73,   73,    0,   57,
        0,   63,   73,   73,   73,   73,    0,   65,    0,   73,
       73,   73,   73,   73,   73,   37,   37,   73,   50,   73,
       73,    0,   59,   73,   65,   73,   50,   73,   73,   73,

       26,   37,    0,   61,   73,    0,   60,    0,   58,   73,
       37,   37,   73,   73,   27,   28,   73,   73,   37,   73,
       73,   29,   73,   73,   73,   73,   73,   73,   73,   73,
       73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
       51,    0
    } ;

static yyconst flex_int32_t yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    5,    6,    7,    8,    9,   10,   11,   12,
       13,   14,   15,   16,   17,   18,   19,   20,   21,   21,
       21,   21,   21,   21,   21,   22,   22,   23,   24,   25,
       26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
       36,   37,   38,   39,   39,   40,   41,   42,   43,   44,
       39,   45,   46,   47,   48,   49,   50,   51,   52,   39,
       53,   54,   55,   29,   56,    1,   57,   58,   59,   60,

       61,   62,   63,   64,   65,   39,   39,   66,   67,   68,
       69,   70,   39,   71,   72,   73,   74,   49,   75,   76,
       77,   39,   78,   29,   79,   80,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst flex_int32_t yy_meta[81] =
    {   0,
        1,    2,    3,    4,    5,    6,    1,    7,    1,    1,
        6,    1,    1,    8,    9,   10,   11,   12,    1,   13,
       13,   14,   15,   16,    1,   17,    1,   18,    1,   19,
       20,   21,   21,   21,   19,   22,   22,   22,   22,   22,
       22,   23,   22,   22,   23,   22,   23,   22,   24,   22,
       25,   22,    1,    6,    1,   26,   19,   20,   21,   21,
       21,   19,   22,   22,   22,   22,   22,   23,   22,   22,
       23,   22,   23,   22,   22,   25,   22,    1,    1,    1
    } ;

static yyconst flex_int16_t yy_base[515] =
    {   0,
        0,   80,  160,    0,  238,  239,  241,  244,  236,  241,
      263,    0,  343,    0, 1068, 3182, 3182, 3182,    0, 1059,
        0, 3182, 3182,  953,  236,    0,  942,    0,    0,  392,
      395,  387,  388,  394,  388,  387,  385,  400,  405,  395,
     3182, 3182,    0,  463,  424,  932,  486,  462,  502,  529,
      572,  538,  540,  568,  505,  569,  570,  612,  613,  592,
     3182, 3182, 3182,  420,  933, 3182, 3182,  904, 3182,    0,
     3182, 3182,  904,  899,  863,    0, 3182, 3182, 3182,  428,
     3182, 3182, 3182,    0, 3182, 3182, 3182,  852,  435,  438,
     3182, 3182,  449, 3182, 3182, 3182, 3182, 3182, 3182,  830,

      455,  487, 3182,  233,  798,  783,  413,    0,  461,  485,
      484,  486,  488, 3182, 3182,  534,  778, 3182,  685,  569,
        0,  617,  518,    0, 3182,    0,  754,  509,  535,  537,
      545,  588,    0,  588,  524,  611,  610,  604,  609,  612,
      720,  765,  646,    0,  767,  752,    0,  758,  781,  792,
      676,  667,  806,  835,  814,  859,  872,  796,  791,  740,
      794,  742,  795,  851,  861,  859,  778,  854,  862,  866,
      554, 3182,  448,  665, 3182, 3182,    0,  630,  613, 3182,
        0,  834,    0, 3182,  860, 3182,  896,    0,    0,  760,
     3182,  900, 3182,  451,    0,  920, 3182, 3182, 3182, 3182,

        0,  798,  858,  858,    0,  880,  899,  946, 3182,  574,
     3182,  976,  950,  959,  560,  966,  524,    0,    0,    0,
        0,  906, 1017, 1012, 1026, 1030, 1015, 1016, 1021, 1022,
     1033,    0, 1025, 1026, 1037,    0, 1070, 3182, 1073,  939,
      786, 1088, 1101, 1112, 1101, 1046, 1080, 1095, 1097, 1038,
     1109, 1116, 1114, 1115, 1118, 1130, 1166,  938,    0,    0,
      944,    0, 3182,    0, 1129,    0, 1138, 1147,  482, 3182,
      474,    0,    0,    0, 1147,    0, 1145, 1059,    0, 1083,
     1146, 1155, 1152, 1164, 1154,    0, 1161, 1156,  970, 1095,
     1201, 1164, 1168, 1184, 1172, 1173, 1192, 1188, 1174, 1196,

     1208, 1205, 1204, 1206, 1212, 1259, 1235,    0, 1243,    0,
     1230, 1200,    0, 1224, 1238, 1233, 1236, 1279, 1250, 1243,
     1243, 1255, 1260,    0, 1195,  563, 1254, 1267, 1263, 1253,
     1296, 1281, 1266, 1278, 1294, 1297, 1264, 1304, 1287, 1292,
     1363, 1301, 1297, 1370, 1374, 3182, 1377, 1294, 1310, 1312,
     1314,  659, 1334, 1388, 1328, 1353, 1395, 1400, 1373, 1368,
     1370, 1371, 1353,  573, 1421, 3182, 1369, 1386, 1446, 3182,
     1453, 3182, 1391,  808, 1460, 1412, 1416, 3182, 1423, 1405,
     1434, 1440, 1427, 1479, 1450, 1413, 1422, 1495,    0, 1431,
     1506, 1510, 3182, 1521, 1432, 1524, 1449, 1465, 1535, 1538,

      379, 1447, 1549, 3182, 1477, 1553, 3182, 1556, 3182, 1504,
     1483, 1498, 1512, 1532,    0,  374, 1514, 1523, 1511, 1529,
     1531,    0, 1532, 1537, 1547, 1548, 1542, 1545, 1538, 1551,
     1551, 1566, 1564, 1584, 1568, 1586, 1574, 1583,  239, 1604,
     3182, 3182, 1670, 1696, 1722, 1748, 1774, 1782, 1807, 1833,
     1851, 1865, 1889, 1907, 1925, 1950, 1970, 1988, 2014, 2040,
     2055, 2081, 2107, 2122, 2148, 2170, 2195, 2209, 2235, 2261,
     2275, 2299, 2317, 2332, 2351, 2372, 2397, 2420, 2441, 2460,
     2486, 2507, 2531, 2546, 2572, 2598, 2613, 2639, 2660, 2667,
     2688, 2714, 2735, 2748, 2757, 2783, 2809, 2835, 2861, 2887,

     2913, 2939, 2965, 2983, 3005, 3027, 3048, 3067, 3093, 3107,
     3116, 3125, 3134, 3155
    } ;

static yyconst flex_int16_t yy_def[515] =
    {   0,
      442,  442,  442,    3,  443,  443,  444,  444,  445,  445,
      442,   11,  442,   13,  442,  442,  442,  442,  446,  447,
      448,  442,  442,  442,  449,  449,  450,  451,  452,  451,
      451,  451,  451,  451,  451,  451,  451,  451,  451,  451,
      442,  442,  449,  453,  454,  455,  456,  457,  458,  458,
      458,   51,   51,   51,   51,   51,   51,   51,   51,   51,
      442,  442,  442,  459,  460,  442,  442,  442,  442,  461,
      442,  442,  462,  462,  442,  463,  442,  442,  442,  442,
      442,  442,  442,  464,  442,  442,  442,  442,  465,  466,
      442,  442,  467,  442,  442,  442,  442,  442,  442,  442,

      442,  442,  442,  442,  442,  442,  468,  468,  468,  468,
      468,  468,  468,  442,  442,  446,  447,  442,  442,  442,
      449,  449,  469,  470,  442,  451,  471,  451,  451,  451,
      451,  451,  451,  451,  451,  451,  451,  451,  451,  451,
      451,  472,  473,  474,  475,  473,  476,  442,  474,  477,
      475,  475,  478,  479,  451,  480,  480,  157,  157,  157,
      157,  157,  157,  157,  157,  157,  157,  157,  157,  157,
      481,  442,  482,  483,  442,  442,  484,  485,  485,  442,
      486,  442,  487,  442,  488,  442,  489,  490,  491,  492,
      442,  493,  442,  442,  494,  442,  442,  442,  442,  442,

      495,  495,  495,  495,  495,  495,  495,  442,  442,  496,
      442,  442,  442,  442,  497,  498,  499,  500,  501,  502,
      503,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  505,  442,  442,  498,  442,
      506,  507,  508,  508,  244,  244,  244,  244,  244,  244,
      244,  244,  244,  244,  244,  244,  509,  442,  510,  491,
      442,  511,  442,  495,  495,  495,  495,  495,  497,  442,
      499,  500,  501,  503,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  506,  506,
      506,  244,  244,  244,  244,  244,  244,  244,  244,  244,

      244,  244,  244,  244,  244,  509,  442,  512,  442,  513,
      495,  495,  495,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  442,  442,  244,  244,  244,  244,
      244,  244,  244,  244,  244,  244,  244,  509,  495,  495,
      504,  504,  504,  504,  442,  442,  504,  504,  504,  504,
      504,  442,  514,  244,  244,  244,  244,  244,  244,  244,
      244,  244,  495,  495,  442,  442,  504,  504,  442,  442,
      442,  442,  504,  504,  504,  504,  514,  442,  514,  244,
      244,  244,  244,  244,  244,  495,  495,  504,  504,  504,
      504,  442,  442,  504,  514,  244,  244,  244,  244,  244,

      495,  495,  442,  442,  504,  442,  442,  442,  442,  244,
      495,  495,  504,  244,  495,  495,  504,  244,  495,  504,
      244,  495,  504,  244,  504,  244,  504,  244,  504,  244,
      504,  244,  504,  244,  504,  244,  504,  244,  504,  244,
      442,    0,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,

      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442
    } ;

static yyconst flex_int16_t yy_nxt[3263] =
    {   0,
       16,   17,   18,   17,   19,   16,   20,   21,   16,   22,
       16,   16,   16,   23,   24,   16,   25,   26,   27,   28,
       28,   28,   29,   16,   16,   16,   26,   26,   26,   30,
       28,   31,   28,   32,   28,   33,   28,   34,   28,   28,
       35,   28,   28,   36,   37,   38,   39,   40,   28,   28,
       28,   28,   16,   16,   16,   28,   30,   28,   31,   28,
       32,   28,   33,   28,   34,   28,   35,   28,   28,   36,
       37,   38,   39,   40,   28,   28,   28,   41,   42,   43,
       16,   44,   18,   44,   19,   16,   20,   21,   16,   22,
       16,   16,   16,   45,   46,   16,   47,   26,   27,   28,

       28,   28,   48,   16,   16,   16,   26,   26,   26,   49,
       50,   51,   50,   52,   50,   53,   50,   54,   50,   50,
       55,   50,   50,   56,   57,   58,   59,   60,   50,   50,
       50,   50,   16,   16,   16,   28,   49,   50,   51,   50,
       52,   50,   53,   50,   54,   50,   55,   50,   50,   56,
       57,   58,   59,   60,   50,   50,   50,   41,   42,   43,
       61,   62,   63,   62,   61,   64,   65,   61,   61,   61,
       61,   61,   66,   61,   61,   67,   61,   61,   68,   61,
       61,   61,   61,   61,   61,   69,   61,   61,   61,   70,
       70,   70,   70,   70,   70,   70,   70,   70,   70,   70,

       70,   70,   70,   70,   70,   70,   70,   70,   70,   70,
       70,   70,   71,   61,   72,   61,   70,   70,   70,   70,
       70,   70,   70,   70,   70,   70,   70,   70,   70,   70,
       70,   70,   70,   70,   70,   70,   70,   61,   61,   61,
       74,   74,   77,   77,   77,   77,   77,   77,   79,  122,
      441,   75,   75,   79,  123,   80,   80,   80,  197,  198,
       80,   80,   80,   81,   82,   83,   82,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   84,   84,   84,   84,   84,   84,   84,   84,

       84,   84,   84,   84,   84,   84,   84,   84,   84,   84,
       84,   84,   84,   84,   84,   81,   81,   81,   81,   84,
       84,   84,   84,   84,   84,   84,   84,   84,   84,   84,
       84,   84,   84,   84,   84,   84,   84,   84,   84,   84,
       81,   81,   81,   85,   86,   87,   86,   88,   89,   85,
       90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
       85,  100,  101,  102,  102,   85,  103,  104,  105,  106,
       85,   85,  107,  108,  109,  108,  108,  108,  108,  108,
      108,  108,  108,  108,  110,  111,  108,  108,  112,  113,
      108,  108,  108,  108,  108,  114,   85,  115,   85,  107,

      108,  109,  108,  108,  108,  108,  108,  108,  108,  108,
      110,  111,  108,  108,  112,  113,  108,  108,  108,  108,
       85,   85,   85,  128,  129,  172,  131,  132,  133,  419,
      135,  136,  137,  138,  411,  134,  141,  130,  140,  147,
      186,  147,  188,  148,  148,  188,  139,  182,  182,  182,
      128,  129,  131,  132,  202,  133,  135,  136,  137,  191,
      138,  134,  141,  130,  142,  140,  142,  257,  257,  151,
      194,  194,  139,  173,  194,  194,  270,  144,  152,  144,
      202,  127,  127,  127,  270,  145,  121,  121,  187,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  122,

      121,  121,  192,  203,  123,  195,  196,  196,  196,  121,
      121,  121,  121,  121,  121,  146,  126,  154,  126,  147,
      219,  155,  155,  126,  207,  126,  270,  204,  205,  203,
      195,  121,  206,  157,  156,  208,  209,  208,  121,  121,
      121,  121,  146,  126,  154,  126,  147,  164,  155,  155,
      126,  207,  126,  204,  205,  222,  228,  126,  206,  172,
      157,  156,  270,  121,  121,  121,  352,  156,  353,  156,
      213,  214,  213,  164,  223,  215,  211,  160,  224,  161,
      156,  222,  156,  228,  126,  146,  126,  154,  126,  147,
      225,  155,  155,  126,  156,  126,  156,  156,  156,  156,

      223,  158,  162,  160,  224,  161,  156,  173,  156,  163,
      156,  156,  156,  165,  159,  179,  225,  166,  216,  214,
      216,  156,  387,  217,  156,  156,  156,  126,  158,  162,
      226,  227,  179,  170,  156,  163,  156,  156,  156,  165,
      159,  156,  156,  166,  229,  167,  169,  387,  156,  231,
      232,  233,  234,  230,  156,  156,  226,  227,  168,  170,
      156,  147,  352,  147,  353,  148,  148,  175,  156,  156,
      240,  229,  167,  169,  442,  231,  232,  233,  234,  230,
      156,  156,  241,  442,  168,  210,  210,  211,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,

      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  212,  212,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  212,  210,  210,  210,
      210,  212,  212,  212,  212,  212,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
      212,  212,  210,  210,  210,  235,  142,  147,  142,  147,
      191,  148,  148,  147,  151,  147,  221,  148,  148,  144,
      118,  144,  237,  238,  237,  246,  156,  145,  156,  289,
      290,  235,  121,  239,  238,  239,  121,  121,  121,  121,

      121,  121,  121,  121,  121,  121,  121,  121,  200,  240,
      121,  246,  156,  192,  156,  121,  121,  121,  121,  121,
      121,  241,  152,  199,  253,  127,  127,  127,  221,  154,
      264,  147,  245,  155,  155,  244,  247,  156,  248,  236,
      156,  156,  156,  193,  121,  121,  121,  121,  236,  126,
      253,  126,  236,  182,  182,  182,  126,  264,  245,  391,
      236,  244,  247,  156,  248,  186,  156,  156,  156,  121,
      121,  121,  146,  126,  154,  126,  147,  184,  155,  155,
      126,  180,  126,  249,  391,  146,  126,  154,  126,  147,
      126,  155,  155,  126,  250,  126,  254,  156,  252,  265,

      156,  179,  255,  251,  266,  156,  179,  156,  156,  267,
      249,  256,  156,  187,  126,  258,  258,  176,  243,  261,
      261,  250,  254,  156,  252,  265,  156,  126,  255,  251,
      266,  156,  268,  156,  156,  175,  267,  256,  156,  196,
      196,  196,  240,  275,  243,  120,  259,  208,  209,  208,
      262,  213,  214,  213,  241,  125,  215,  307,  307,  268,
      213,  214,  213,  309,  309,  215,  120,  216,  214,  216,
      275,  259,  217,  289,  290,  262,  210,  210,  211,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,

      210,  210,  210,  210,  210,  212,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  212,  212,  210,  210,
      210,  210,  212,  212,  212,  212,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
      212,  212,  212,  210,  210,  210,  276,  277,  278,  279,
      280,  118,  281,  282,  283,  284,  285,  442,  286,  287,
      288,  237,  238,  237,  239,  238,  239,  156,  442,  296,
      442,  300,  276,  277,  278,  156,  279,  280,  281,  282,
      283,  284,  236,  285,  286,  287,  316,  288,  442,  442,

      442,  236,  126,  156,  126,  236,  296,  300,  442,  126,
      297,  156,  317,  236,  146,  126,  154,  126,  147,  156,
      155,  155,  126,  316,  126,  146,  126,  154,  126,  147,
      442,  155,  155,  126,  156,  126,  156,  297,  292,  317,
      156,  442,  298,  126,  299,  156,  294,  295,  156,  302,
      442,  293,  301,  156,  156,  156,  126,  156,  303,  442,
      156,  304,  156,  305,  442,  292,  156,  126,  298,  156,
      299,  172,  294,  295,  156,  311,  302,  293,  301,  156,
      156,  156,  312,  156,  303,  306,  306,  304,  313,  314,
      305,  315,  318,  442,  319,  156,  320,  321,  325,  322,

      323,  311,  324,  156,  325,  442,  327,  156,  312,  329,
      326,  156,  156,  332,  313,  314,  326,  315,  318,  173,
      319,  330,  320,  156,  321,  322,  323,  156,  324,  156,
      328,  156,  327,  156,  331,  156,  329,  156,  156,  332,
      333,  334,  442,  156,  156,  336,  340,  156,  330,  156,
      335,  156,  442,  156,  185,  185,  328,  156,  337,  339,
      331,  156,  190,  190,  172,  341,  333,  342,  334,  156,
      156,  336,  340,  156,  343,  344,  335,  156,  338,  338,
      345,  345,  345,  347,  337,  348,  339,  349,  350,  351,
      346,  341,  357,  156,  342,  354,  355,  345,  345,  345,

      343,  344,  156,  156,  356,  156,  156,  346,  359,  172,
      347,  348,  173,  349,  358,  350,  351,  156,  357,  156,
      156,  354,  360,  355,  363,  373,  362,  361,  156,  156,
      356,  156,  156,  156,  359,  156,  156,  364,  442,  378,
      442,  358,  367,  156,  368,  442,  156,  442,  360,  442,
      442,  363,  373,  362,  361,  442,  374,  173,  375,  156,
      376,  156,  156,  364,  365,  365,  365,  156,  367,  380,
      368,  369,  369,  369,  366,  345,  345,  345,  371,  371,
      371,  370,  374,  442,  375,  346,  376,  379,  372,  365,
      365,  365,  156,  156,  386,  380,  369,  369,  369,  366,

      381,  371,  371,  371,  382,  442,  370,  156,  442,  156,
      156,  372,  156,  442,  383,  388,  384,  385,  156,  389,
      386,  378,  365,  365,  365,  390,  381,  156,  395,  442,
      442,  382,  366,  156,  156,  156,  156,  378,  156,  156,
      383,  388,  384,  385,  156,  394,  389,  369,  369,  369,
      442,  396,  390,  156,  371,  371,  371,  370,  401,  402,
      156,  392,  392,  392,  372,  156,  156,  397,  405,  379,
      156,  393,  394,  156,  398,  442,  379,  396,  399,  156,
      392,  392,  392,  400,  401,  379,  402,  442,  156,  156,
      393,  442,  156,  412,  397,  405,  403,  403,  403,  156,

      442,  398,  410,  399,  156,  156,  404,  406,  406,  406,
      400,  392,  392,  392,  156,  156,  413,  407,  156,  412,
      415,  393,  408,  408,  408,  403,  403,  403,  442,  410,
      156,  442,  409,  442,  416,  404,  406,  406,  406,  408,
      408,  408,  413,  414,  156,  417,  407,  415,  422,  409,
      403,  403,  403,  420,  406,  406,  406,  408,  408,  408,
      404,  416,  421,  156,  407,  418,  423,  409,  424,  414,
      156,  156,  417,  425,  156,  422,  156,  156,  426,  420,
      427,  428,  442,  429,  156,  431,  430,  156,  421,  156,
      156,  433,  418,  423,  435,  424,  156,  156,  432,  425,

      156,  437,  156,  156,  426,  156,  434,  427,  428,  429,
      156,  431,  430,  156,  436,  441,  156,  433,  439,  438,
      442,  435,  156,  156,  432,  156,  442,  440,  437,  442,
      442,  156,  434,  442,  442,  442,  442,  442,  442,  442,
      442,  436,  442,  156,  439,  442,  438,  442,  156,  156,
      442,  156,  442,  440,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  156,
       73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
       73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
       73,   73,   73,   73,   73,   73,   76,   76,   76,   76,

       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   78,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,  116,  442,
      442,  442,  116,  116,  116,  116,  116,  116,  116,  116,
      116,  116,  116,  116,  116,  116,  116,  116,  116,  116,
      116,  116,  116,  116,  117,  117,  117,  117,  117,  117,
      117,  117,  117,  117,  117,  117,  117,  117,  117,  117,
      117,  117,  117,  117,  117,  117,  117,  117,  117,  117,

      119,  119,  119,  119,  119,  119,  119,  121,  121,  442,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  124,  124,  124,  124,  124,  124,  124,
      124,  124,  124,  124,  124,  124,  124,  124,  124,  124,
      124,  124,  124,  124,  124,  124,  124,  124,  124,  126,
      126,  126,  442,  126,  126,  442,  126,  442,  442,  126,
      126,  126,  126,  126,  126,  126,  126,  127,  127,  442,
      442,  442,  442,  127,  127,  127,  127,  127,  127,  127,
      143,  442,  143,  442,  442,  442,  143,  143,  442,  143,

      442,  442,  442,  143,  442,  442,  442,  143,  143,  143,
      143,  143,  143,  143,  146,  442,  146,  442,  146,  146,
      442,  442,  442,  442,  442,  146,  146,  146,  146,  146,
      146,  146,  149,  442,  442,  149,  149,  149,  149,  149,
      442,  442,  442,  149,  149,  149,  149,  149,  149,  149,
      150,  150,  442,  150,  150,  150,  150,  150,  150,  150,
      150,  150,  150,  150,  150,  150,  150,  150,  150,  150,
      150,  150,  150,  150,  150,  150,  153,  442,  442,  442,
      153,  442,  153,  153,  442,  442,  442,  442,  153,  153,
      153,  153,  153,  153,  153,  156,  156,  156,  156,  156,

      156,  156,  442,  156,  442,  442,  156,  156,  156,  156,
      156,  156,  156,  156,  171,  171,  171,  171,  171,  171,
      171,  171,  171,  171,  171,  171,  171,  171,  171,  171,
      171,  171,  171,  171,  171,  171,  171,  171,  171,  171,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  177,  177,  177,  442,
      442,  442,  442,  177,  177,  177,  177,  177,  177,  177,
      177,  178,  178,  178,  178,  178,  178,  178,  442,  178,
      178,  178,  178,  178,  178,  178,  178,  178,  178,  178,

      178,  178,  178,  178,  178,  178,  178,  181,  442,  442,
      442,  181,  181,  181,  181,  181,  181,  181,  181,  181,
      181,  181,  181,  181,  181,  181,  181,  181,  181,  181,
      181,  181,  181,  183,  183,  183,  442,  442,  442,  442,
      183,  183,  183,  183,  183,  183,  183,  183,  185,  185,
      185,  185,  185,  185,  442,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  189,  442,  189,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  189,  189,
      189,  189,  189,  189,  189,  190,  190,  190,  190,  190,

      190,  190,  190,  190,  190,  190,  190,  190,  190,  190,
      190,  190,  190,  190,  190,  190,  190,  190,  190,  190,
      190,  201,  201,  442,  442,  442,  442,  201,  201,  201,
      201,  201,  201,  201,  201,  218,  218,  218,  218,  218,
      218,  218,  218,  218,  218,  218,  218,  218,  218,  218,
      218,  218,  218,  218,  218,  218,  218,  218,  218,  218,
      218,  220,  220,  442,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  127,  127,  127,
      442,  442,  442,  127,  127,  127,  127,  127,  127,  127,

      143,  442,  143,  442,  442,  442,  143,  143,  442,  143,
      442,  442,  442,  143,  442,  442,  442,  143,  143,  143,
      143,  143,  143,  143,  146,  442,  146,  442,  146,  146,
      442,  442,  442,  442,  442,  146,  146,  146,  146,  146,
      146,  146,  149,  149,  149,  149,  149,  442,  442,  442,
      149,  149,  149,  149,  149,  149,  149,  152,  442,  442,
      442,  152,  442,  442,  442,  442,  442,  442,  442,  152,
      152,  152,  152,  152,  152,  152,  236,  442,  442,  236,
      442,  236,  442,  236,  236,  442,  442,  236,  236,  442,
      236,  236,  236,  236,  236,  236,  236,  150,  150,  150,

      150,  150,  150,  150,  150,  150,  150,  150,  150,  150,
      150,  150,  150,  150,  150,  150,  150,  150,  150,  150,
      150,  150,  150,  153,  442,  442,  442,  442,  442,  153,
      153,  442,  153,  153,  153,  442,  442,  442,  153,  153,
      153,  153,  153,  153,  153,  242,  442,  442,  242,  242,
      242,  242,  242,  242,  242,  442,  242,  242,  442,  242,
      242,  242,  242,  242,  242,  242,  242,  156,  156,  156,
      156,  156,  156,  156,  442,  156,  442,  442,  156,  156,
      156,  156,  156,  156,  156,  156,  171,  171,  171,  171,
      171,  171,  171,  171,  171,  171,  171,  171,  171,  171,

      171,  171,  171,  171,  171,  171,  171,  171,  171,  171,
      171,  171,  171,  442,  442,  442,  442,  442,  442,  171,
      442,  442,  442,  442,  171,  171,  171,  442,  442,  171,
      171,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  177,  177,  177,
      442,  442,  442,  442,  177,  177,  177,  177,  177,  177,
      177,  177,  178,  178,  178,  178,  178,  178,  178,  442,
      178,  178,  178,  178,  178,  178,  178,  178,  178,  178,
      178,  178,  178,  178,  178,  178,  178,  178,  181,  442,

      442,  442,  181,  181,  181,  181,  181,  181,  181,  181,
      181,  181,  181,  181,  181,  181,  181,  181,  181,  181,
      181,  181,  181,  181,  183,  183,  183,  442,  442,  442,
      442,  183,  183,  183,  183,  183,  183,  183,  183,  185,
      185,  185,  185,  185,  185,  442,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  442,  442,  442,
      442,  442,  185,  442,  442,  442,  442,  442,  442,  185,
      442,  442,  185,  442,  185,  189,  189,  189,  189,  189,
      189,  189,  260,  442,  442,  442,  442,  442,  260,  260,

      260,  260,  442,  442,  442,  442,  260,  260,  260,  260,
      260,  260,  260,  260,  190,  190,  190,  190,  190,  190,
      190,  190,  190,  190,  190,  190,  190,  190,  190,  190,
      190,  190,  190,  190,  190,  190,  190,  190,  190,  190,
      190,  190,  442,  442,  442,  442,  442,  190,  442,  442,
      442,  442,  442,  442,  190,  442,  442,  190,  442,  190,
      263,  442,  442,  442,  442,  442,  263,  263,  263,  201,
      201,  442,  442,  442,  442,  201,  201,  201,  201,  201,
      201,  201,  201,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,

      210,  210,  210,  210,  210,  210,  210,  210,  210,  269,
      269,  269,  269,  269,  269,  269,  269,  269,  269,  269,
      269,  269,  269,  269,  269,  269,  269,  269,  269,  269,
      269,  269,  269,  269,  269,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  271,  271,  271,  271,  271,  271,  271,  271,  271,
      271,  271,  271,  271,  271,  271,  271,  271,  271,  271,
      271,  271,  271,  271,  271,  271,  271,  272,  272,  442,
      272,  272,  272,  272,  272,  272,  272,  272,  272,  272,

      272,  272,  272,  272,  272,  272,  272,  272,  272,  272,
      272,  272,  272,  273,  273,  442,  273,  273,  273,  273,
      273,  273,  273,  273,  273,  273,  273,  273,  273,  273,
      273,  273,  273,  273,  273,  273,  273,  273,  273,  220,
      220,  442,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  274,  274,  442,  274,  274,
      274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
      274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
      274,  126,  126,  126,  442,  126,  126,  442,  126,  442,

      442,  126,  126,  126,  126,  126,  126,  126,  126,  236,
      442,  442,  236,  442,  236,  442,  236,  236,  442,  442,
      236,  236,  442,  236,  236,  236,  236,  236,  236,  236,
      291,  291,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  291,  291,  291,  291,  291,
      291,  291,  242,  442,  442,  242,  242,  242,  242,  242,
      242,  242,  442,  242,  242,  442,  242,  242,  242,  242,
      242,  242,  242,  242,  156,  156,  156,  156,  156,  156,
      156,  442,  156,  442,  442,  156,  156,  156,  156,  156,
      156,  156,  156,  171,  171,  171,  171,  171,  171,  171,

      171,  171,  171,  171,  171,  171,  171,  171,  171,  171,
      171,  171,  171,  171,  171,  171,  171,  171,  171,  308,
      308,  442,  442,  442,  442,  308,  308,  308,  310,  310,
      442,  442,  442,  442,  310,  310,  310,  185,  185,  442,
      442,  442,  442,  185,  185,  185,  190,  190,  442,  442,
      442,  442,  190,  190,  190,  377,  377,  377,  377,  377,
      377,  377,  377,  377,  377,  377,  377,  377,  377,  377,
      377,  377,  377,  377,  377,  377,  377,  377,  377,  377,
      377,   15,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,

      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442
    } ;

static yyconst flex_int16_t yy_chk[3263] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,

        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        5,    6,    7,    7,    7,    8,    8,    8,    9,   25,
      439,    5,    6,   10,   25,    9,    9,    9,  104,  104,
       10,   10,   10,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,

       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,

       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   30,   31,   64,   32,   33,   34,  416,
       35,   36,   37,   38,  401,   34,   40,   31,   39,   45,
       89,   45,   90,   45,   45,   90,   38,   80,   80,   80,
       30,   31,   32,   33,  107,   34,   35,   36,   37,   93,
       38,   34,   40,   31,   44,   39,   44,  173,  173,   48,
      194,  194,   38,   64,  101,  101,  271,   44,   48,   44,
      107,   48,   48,   48,  269,   44,   47,   47,   89,   47,
       47,   47,   47,   47,   47,   47,   47,   47,   47,   47,

       47,   47,   93,  109,   47,  101,  102,  102,  102,   47,
       47,   47,   47,   47,   47,   49,   49,   49,   49,   49,
      123,   49,   49,   49,  113,   49,  217,  110,  111,  109,
      101,  123,  112,   49,   55,  116,  116,  116,   47,   47,
       47,   47,   50,   50,   50,   50,   50,   55,   50,   50,
       50,  113,   50,  110,  111,  128,  135,   49,  112,  171,
       49,   55,  215,   47,   47,   47,  326,   52,  326,   53,
      120,  120,  120,   55,  129,  120,  210,   52,  130,   53,
       52,  128,   53,  135,   50,   51,   51,   51,   51,   51,
      131,   51,   51,   51,   52,   51,   53,   54,   56,   57,

      129,   51,   54,   52,  130,   53,   52,  171,   53,   54,
       54,   56,   57,   56,   51,  179,  131,   57,  122,  122,
      122,   60,  364,  122,   54,   56,   57,   51,   51,   54,
      132,  134,  178,   60,   60,   54,   54,   56,   57,   56,
       51,   58,   59,   57,  136,   58,   59,  364,   60,  137,
      138,  139,  140,  136,   58,   59,  132,  134,   58,   60,
       60,  143,  352,  143,  352,  143,  143,  174,   58,   59,
      152,  136,   58,   59,  152,  137,  138,  139,  140,  136,
       58,   59,  152,  151,   58,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,

      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  141,  142,  146,  142,  146,
      190,  146,  146,  148,  145,  148,  127,  148,  148,  142,
      117,  142,  149,  149,  149,  160,  160,  142,  162,  241,
      241,  141,  150,  150,  150,  150,  150,  150,  150,  150,

      150,  150,  150,  150,  150,  150,  150,  150,  106,  153,
      150,  160,  160,  190,  162,  150,  150,  150,  150,  150,
      150,  153,  153,  105,  167,  153,  153,  153,  153,  155,
      202,  155,  159,  155,  155,  158,  161,  159,  163,  154,
      161,  163,  158,  100,  150,  150,  150,  150,  154,  154,
      167,  154,  154,  182,  182,  182,  154,  202,  159,  374,
      154,  158,  161,  159,  163,  185,  161,  163,  158,  150,
      150,  150,  156,  156,  156,  156,  156,   88,  156,  156,
      156,   75,  156,  164,  374,  157,  157,  157,  157,  157,
      154,  157,  157,  157,  165,  157,  168,  164,  166,  203,

      168,   74,  169,  165,  204,  166,   73,  165,  169,  206,
      164,  170,  170,  185,  156,  187,  187,   68,  157,  192,
      192,  165,  168,  164,  166,  203,  168,  157,  169,  165,
      204,  166,  207,  165,  169,   65,  206,  170,  170,  196,
      196,  196,  240,  222,  157,   46,  187,  208,  208,  208,
      192,  213,  213,  213,  240,   27,  213,  258,  258,  207,
      214,  214,  214,  261,  261,  214,   24,  216,  216,  216,
      222,  187,  216,  289,  289,  192,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  212,  212,  212,  212,

      212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  223,  224,  224,  225,
      226,   20,  227,  228,  229,  230,  231,   15,  233,  234,
      235,  237,  237,  237,  239,  239,  239,  250,    0,  246,
        0,  250,  223,  224,  224,  246,  225,  226,  227,  228,
      229,  230,  242,  231,  233,  234,  278,  235,  290,  290,

        0,  242,  242,  250,  242,  242,  246,  250,    0,  242,
      247,  246,  280,  242,  243,  243,  243,  243,  243,  247,
      243,  243,  243,  278,  243,  244,  244,  244,  244,  244,
        0,  244,  244,  244,  248,  244,  249,  247,  243,  280,
      245,    0,  248,  242,  249,  247,  245,  245,  251,  252,
        0,  244,  251,  253,  254,  252,  243,  255,  254,    0,
      248,  255,  249,  256,    0,  243,  245,  244,  248,  256,
      249,  257,  245,  245,  251,  265,  252,  244,  251,  253,
      254,  252,  267,  255,  254,  257,  257,  255,  268,  275,
      256,  277,  281,    0,  282,  256,  283,  284,  325,  285,

      287,  265,  288,  292,  291,  291,  292,  293,  267,  295,
      325,  295,  296,  299,  268,  275,  291,  277,  281,  257,
      282,  297,  283,  294,  284,  285,  287,  298,  288,  292,
      294,  297,  292,  293,  298,  300,  295,  295,  296,  299,
      300,  301,    0,  303,  302,  304,  312,  301,  297,  294,
      302,  305,    0,  298,  307,  307,  294,  297,  305,  311,
      298,  300,  309,  309,  306,  314,  300,  315,  301,  303,
      302,  304,  312,  301,  316,  317,  302,  305,  306,  306,
      318,  318,  318,  319,  305,  320,  311,  321,  322,  323,
      318,  314,  330,  327,  315,  327,  328,  331,  331,  331,

      316,  317,  329,  337,  329,  333,  328,  331,  333,  338,
      319,  320,  306,  321,  332,  322,  323,  334,  330,  327,
      332,  327,  334,  328,  339,  348,  336,  335,  329,  337,
      329,  333,  328,  335,  333,  331,  336,  340,    0,  353,
        0,  332,  342,  334,  343,    0,  332,    0,  334,    0,
        0,  339,  348,  336,  335,    0,  349,  338,  350,  335,
      351,  331,  336,  340,  341,  341,  341,  355,  342,  355,
      343,  344,  344,  344,  341,  345,  345,  345,  347,  347,
      347,  344,  349,    0,  350,  345,  351,  353,  347,  354,
      354,  354,  356,  355,  363,  355,  357,  357,  357,  354,

      356,  358,  358,  358,  359,    0,  357,  360,    0,  361,
      362,  358,  359,    0,  360,  367,  361,  362,  356,  368,
      363,  377,  365,  365,  365,  373,  356,  354,  379,    0,
        0,  359,  365,  360,  357,  361,  362,  395,  359,  358,
      360,  367,  361,  362,  380,  376,  368,  369,  369,  369,
        0,  380,  373,  354,  371,  371,  371,  369,  386,  387,
      357,  375,  375,  375,  371,  358,  383,  381,  390,  377,
      380,  375,  376,  381,  382,    0,  379,  380,  383,  382,
      384,  384,  384,  385,  386,  395,  387,    0,  397,  385,
      384,    0,  383,  402,  381,  390,  388,  388,  388,  381,

        0,  382,  398,  383,  398,  382,  388,  391,  391,  391,
      385,  392,  392,  392,  397,  385,  405,  391,  384,  402,
      411,  392,  394,  394,  394,  396,  396,  396,    0,  398,
      398,    0,  394,    0,  412,  396,  399,  399,  399,  400,
      400,  400,  405,  410,  384,  413,  399,  411,  419,  400,
      403,  403,  403,  417,  406,  406,  406,  408,  408,  408,
      403,  412,  418,  396,  406,  414,  420,  408,  421,  410,
      421,  414,  413,  423,  399,  419,  424,  400,  424,  417,
      425,  426,    0,  427,  428,  429,  428,  426,  418,  396,
      430,  431,  414,  420,  433,  421,  421,  414,  430,  423,

      399,  435,  424,  400,  424,  432,  432,  425,  426,  427,
      428,  429,  428,  426,  434,  440,  430,  431,  437,  436,
        0,  433,  438,  434,  430,  436,    0,  438,  435,    0,
        0,  432,  432,    0,    0,    0,    0,    0,    0,    0,
        0,  434,    0,  440,  437,    0,  436,    0,  438,  434,
        0,  436,    0,  438,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,  440,
      443,  443,  443,  443,  443,  443,  443,  443,  443,  443,
      443,  443,  443,  443,  443,  443,  443,  443,  443,  443,
      443,  443,  443,  443,  443,  443,  444,  444,  444,  444,

      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  445,  445,  445,  445,  445,  445,  445,  445,
      445,  445,  445,  445,  445,  445,  445,  445,  445,  445,
      445,  445,  445,  445,  445,  445,  445,  445,  446,    0,
        0,    0,  446,  446,  446,  446,  446,  446,  446,  446,
      446,  446,  446,  446,  446,  446,  446,  446,  446,  446,
      446,  446,  446,  446,  447,  447,  447,  447,  447,  447,
      447,  447,  447,  447,  447,  447,  447,  447,  447,  447,
      447,  447,  447,  447,  447,  447,  447,  447,  447,  447,

      448,  448,  448,  448,  448,  448,  448,  449,  449,    0,
      449,  449,  449,  449,  449,  449,  449,  449,  449,  449,
      449,  449,  449,  449,  449,  449,  449,  449,  449,  449,
      449,  449,  449,  450,  450,  450,  450,  450,  450,  450,
      450,  450,  450,  450,  450,  450,  450,  450,  450,  450,
      450,  450,  450,  450,  450,  450,  450,  450,  450,  451,
      451,  451,    0,  451,  451,    0,  451,    0,    0,  451,
      451,  451,  451,  451,  451,  451,  451,  452,  452,    0,
        0,    0,    0,  452,  452,  452,  452,  452,  452,  452,
      453,    0,  453,    0,    0,    0,  453,  453,    0,  453,

        0,    0,    0,  453,    0,    0,    0,  453,  453,  453,
      453,  453,  453,  453,  454,    0,  454,    0,  454,  454,
        0,    0,    0,    0,    0,  454,  454,  454,  454,  454,
      454,  454,  455,    0,    0,  455,  455,  455,  455,  455,
        0,    0,    0,  455,  455,  455,  455,  455,  455,  455,
      456,  456,    0,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  457,    0,    0,    0,
      457,    0,  457,  457,    0,    0,    0,    0,  457,  457,
      457,  457,  457,  457,  457,  458,  458,  458,  458,  458,

      458,  458,    0,  458,    0,    0,  458,  458,  458,  458,
      458,  458,  458,  458,  459,  459,  459,  459,  459,  459,
      459,  459,  459,  459,  459,  459,  459,  459,  459,  459,
      459,  459,  459,  459,  459,  459,  459,  459,  459,  459,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  461,  461,  461,    0,
        0,    0,    0,  461,  461,  461,  461,  461,  461,  461,
      461,  462,  462,  462,  462,  462,  462,  462,    0,  462,
      462,  462,  462,  462,  462,  462,  462,  462,  462,  462,

      462,  462,  462,  462,  462,  462,  462,  463,    0,    0,
        0,  463,  463,  463,  463,  463,  463,  463,  463,  463,
      463,  463,  463,  463,  463,  463,  463,  463,  463,  463,
      463,  463,  463,  464,  464,  464,    0,    0,    0,    0,
      464,  464,  464,  464,  464,  464,  464,  464,  465,  465,
      465,  465,  465,  465,    0,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  465,  466,    0,  466,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,  466,  466,
      466,  466,  466,  466,  466,  467,  467,  467,  467,  467,

      467,  467,  467,  467,  467,  467,  467,  467,  467,  467,
      467,  467,  467,  467,  467,  467,  467,  467,  467,  467,
      467,  468,  468,    0,    0,    0,    0,  468,  468,  468,
      468,  468,  468,  468,  468,  469,  469,  469,  469,  469,
      469,  469,  469,  469,  469,  469,  469,  469,  469,  469,
      469,  469,  469,  469,  469,  469,  469,  469,  469,  469,
      469,  470,  470,    0,  470,  470,  470,  470,  470,  470,
      470,  470,  470,  470,  470,  470,  470,  470,  470,  470,
      470,  470,  470,  470,  470,  470,  470,  471,  471,  471,
        0,    0,    0,  471,  471,  471,  471,  471,  471,  471,

      472,    0,  472,    0,    0,    0,  472,  472,    0,  472,
        0,    0,    0,  472,    0,    0,    0,  472,  472,  472,
      472,  472,  472,  472,  473,    0,  473,    0,  473,  473,
        0,    0,    0,    0,    0,  473,  473,  473,  473,  473,
      473,  473,  474,  474,  474,  474,  474,    0,    0,    0,
      474,  474,  474,  474,  474,  474,  474,  475,    0,    0,
        0,  475,    0,    0,    0,    0,    0,    0,    0,  475,
      475,  475,  475,  475,  475,  475,  476,    0,    0,  476,
        0,  476,    0,  476,  476,    0,    0,  476,  476,    0,
      476,  476,  476,  476,  476,  476,  476,  477,  477,  477,

      477,  477,  477,  477,  477,  477,  477,  477,  477,  477,
      477,  477,  477,  477,  477,  477,  477,  477,  477,  477,
      477,  477,  477,  478,    0,    0,    0,    0,    0,  478,
      478,    0,  478,  478,  478,    0,    0,    0,  478,  478,
      478,  478,  478,  478,  478,  479,    0,    0,  479,  479,
      479,  479,  479,  479,  479,    0,  479,  479,    0,  479,
      479,  479,  479,  479,  479,  479,  479,  480,  480,  480,
      480,  480,  480,  480,    0,  480,    0,    0,  480,  480,
      480,  480,  480,  480,  480,  480,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  482,    0,    0,    0,    0,    0,    0,  482,
        0,    0,    0,    0,  482,  482,  482,    0,    0,  482,
      482,  483,  483,  483,  483,  483,  483,  483,  483,  483,
      483,  483,  483,  483,  483,  483,  483,  483,  483,  483,
      483,  483,  483,  483,  483,  483,  483,  484,  484,  484,
        0,    0,    0,    0,  484,  484,  484,  484,  484,  484,
      484,  484,  485,  485,  485,  485,  485,  485,  485,    0,
      485,  485,  485,  485,  485,  485,  485,  485,  485,  485,
      485,  485,  485,  485,  485,  485,  485,  485,  486,    0,

        0,    0,  486,  486,  486,  486,  486,  486,  486,  486,
      486,  486,  486,  486,  486,  486,  486,  486,  486,  486,
      486,  486,  486,  486,  487,  487,  487,    0,    0,    0,
        0,  487,  487,  487,  487,  487,  487,  487,  487,  488,
      488,  488,  488,  488,  488,    0,  488,  488,  488,  488,
      488,  488,  488,  488,  488,  488,  488,  488,  488,  488,
      488,  488,  488,  488,  488,  489,  489,    0,    0,    0,
        0,    0,  489,    0,    0,    0,    0,    0,    0,  489,
        0,    0,  489,    0,  489,  490,  490,  490,  490,  490,
      490,  490,  491,    0,    0,    0,    0,    0,  491,  491,

      491,  491,    0,    0,    0,    0,  491,  491,  491,  491,
      491,  491,  491,  491,  492,  492,  492,  492,  492,  492,
      492,  492,  492,  492,  492,  492,  492,  492,  492,  492,
      492,  492,  492,  492,  492,  492,  492,  492,  492,  492,
      493,  493,    0,    0,    0,    0,    0,  493,    0,    0,
        0,    0,    0,    0,  493,    0,    0,  493,    0,  493,
      494,    0,    0,    0,    0,    0,  494,  494,  494,  495,
      495,    0,    0,    0,    0,  495,  495,  495,  495,  495,
      495,  495,  495,  496,  496,  496,  496,  496,  496,  496,
      496,  496,  496,  496,  496,  496,  496,  496,  496,  496,

      496,  496,  496,  496,  496,  496,  496,  496,  496,  497,
      497,  497,  497,  497,  497,  497,  497,  497,  497,  497,
      497,  497,  497,  497,  497,  497,  497,  497,  497,  497,
      497,  497,  497,  497,  497,  498,  498,  498,  498,  498,
      498,  498,  498,  498,  498,  498,  498,  498,  498,  498,
      498,  498,  498,  498,  498,  498,  498,  498,  498,  498,
      498,  499,  499,  499,  499,  499,  499,  499,  499,  499,
      499,  499,  499,  499,  499,  499,  499,  499,  499,  499,
      499,  499,  499,  499,  499,  499,  499,  500,  500,    0,
      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,

      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
      500,  500,  500,  501,  501,    0,  501,  501,  501,  501,
      501,  501,  501,  501,  501,  501,  501,  501,  501,  501,
      501,  501,  501,  501,  501,  501,  501,  501,  501,  502,
      502,    0,  502,  502,  502,  502,  502,  502,  502,  502,
      502,  502,  502,  502,  502,  502,  502,  502,  502,  502,
      502,  502,  502,  502,  502,  503,  503,    0,  503,  503,
      503,  503,  503,  503,  503,  503,  503,  503,  503,  503,
      503,  503,  503,  503,  503,  503,  503,  503,  503,  503,
      503,  504,  504,  504,    0,  504,  504,    0,  504,    0,

        0,  504,  504,  504,  504,  504,  504,  504,  504,  505,
        0,    0,  505,    0,  505,    0,  505,  505,    0,    0,
      505,  505,    0,  505,  505,  505,  505,  505,  505,  505,
      506,  506,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,  506,  506,  506,  506,  506,
      506,  506,  507,    0,    0,  507,  507,  507,  507,  507,
      507,  507,    0,  507,  507,    0,  507,  507,  507,  507,
      507,  507,  507,  507,  508,  508,  508,  508,  508,  508,
      508,    0,  508,    0,    0,  508,  508,  508,  508,  508,
      508,  508,  508,  509,  509,  509,  509,  509,  509,  509,

      509,  509,  509,  509,  509,  509,  509,  509,  509,  509,
      509,  509,  509,  509,  509,  509,  509,  509,  509,  510,
      510,    0,    0,    0,    0,  510,  510,  510,  511,  511,
        0,    0,    0,    0,  511,  511,  511,  512,  512,    0,
        0,    0,    0,  512,  512,  512,  513,  513,    0,    0,
        0,    0,  513,  513,  513,  514,  514,  514,  514,  514,
      514,  514,  514,  514,  514,  514,  514,  514,  514,  514,
      514,  514,  514,  514,  514,  514,  514,  514,  514,  514,
      514,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,

      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442
    } ;

/* Table of booleans, true if rule could match eol. */
static yyconst flex_int32_t yy_rule_can_match_eol[98] =
    {   0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 1, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 1, 1, 
    1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 
    1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0,     };

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lexer.l"
/* Lex file for rsyslog config format v2 (RainerScript).
* Please note: this file introduces the new config format, but maintains
* backward compatibility. In order to do so, the grammar is not 100% clean,
* but IMHO still sufficiently easy both to understand for programmers
* maitaining the code as well as users writing the config file. Users are,
* of course, encouraged to use new constructs only. But it needs to be noted
* that some of the legacy constructs (specifically the in-front-of-action
* PRI filter) are very hard to beat in ease of use, at least for simpler
* cases. So while we hope that cfsysline support can be dropped some time in
* the future, we will probably keep these useful constructs.
*
* Copyright 2011-2012 Rainer Gerhards and Adiscon GmbH.
*
* This file is part of the rsyslog runtime library.
*
* The rsyslog runtime library is free software: you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* The rsyslog runtime library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with the rsyslog runtime library.  If not, see <http://www.gnu.org/licenses/>.
*
* A copy of the GPL can be found in the file "COPYING" in this distribution.
* A copy of the LGPL can be found in the file "COPYING.LESSER" in this distribution.
*/
/*%option noyywrap nodefault case-insensitive */
/* avoid compiler warning: `yyunput' defined but not used */
#define YY_NO_INPUT 1

/* INOBJ is selected if we are inside an object (name/value pairs!) */

/* COMMENT is "the usual trick" to handle C-style comments */

/* INCL is in $IncludeConfig processing (skip to include file) */

/* LINENO: support for setting the linenumber */

/* INCALL: support for the call statement */

/* EXPR is a bit ugly, but we need it to support pre v6-syntax. The problem
* is that cfsysline statement start with $..., the same like variables in
* an expression. However, cfsysline statements can never appear inside an
* expression. So we create a specific expr mode, which is turned on after 
* we lexed a keyword that needs to be followed by an expression (using 
* knowledge from the upper layer...). In expr mode, we strictly do
* expression-based parsing. Expr mode is stopped when we reach a token
* that can not be part of an expression (currently only "then"). As I
* wrote this ugly, but the price needed to pay in order to remain
* compatible to the previous format.
*/
#line 63 "lexer.l"
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <libestr.h>
#include "rainerscript.h"
#include "parserif.h"
#include "grammar.h"
static int preCommentState;	/* save for lex state before a comment */

struct bufstack {
	struct bufstack *prev;
	YY_BUFFER_STATE bs;
	int lineno;
	char *fn;
	es_str_t *estr;
} *currbs = NULL;

char *cnfcurrfn;			/* name of currently processed file */

int popfile(void);
int cnfSetLexFile(char *fname);

extern int yydebug;

/* somehow, I need these prototype even though the headers are 
 * included. I guess that's some autotools magic I don't understand...
 */
int fileno(FILE *stream);

#line 1453 "lexer.c"

#define INITIAL 0
#define INOBJ 1
#define COMMENT 2
#define INCL 3
#define LINENO 4
#define INCALL 5
#define EXPR 6

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals (void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy (void );

int yyget_debug (void );

void yyset_debug (int debug_flag  );

YY_EXTRA_TYPE yyget_extra (void );

void yyset_extra (YY_EXTRA_TYPE user_defined  );

FILE *yyget_in (void );

void yyset_in  (FILE * in_str  );

FILE *yyget_out (void );

void yyset_out  (FILE * out_str  );

int yyget_leng (void );

char *yyget_text (void );

int yyget_lineno (void );

void yyset_lineno (int line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap (void );
#else
extern int yywrap (void );
#endif
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * );
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (void );
#else
static int input (void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		size_t n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, yyin))==0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex (void);

#define YY_DECL int yylex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	if ( yyleng > 0 ) \
		YY_CURRENT_BUFFER_LVALUE->yy_at_bol = \
				(yytext[yyleng - 1] == '\n'); \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;
    
#line 95 "lexer.l"


 /* keywords */
#line 1651 "lexer.c"

	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer(yyin,YY_BUF_SIZE );
		}

		yy_load_buffer_state( );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
		yy_current_state += YY_AT_BOL();
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 443 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 3182 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

		if ( yy_act != YY_END_OF_BUFFER && yy_rule_can_match_eol[yy_act] )
			{
			int yyl;
			for ( yyl = 0; yyl < yyleng; ++yyl )
				if ( yytext[yyl] == '\n' )
					   
    yylineno++;
;
			}

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
YY_RULE_SETUP
#line 98 "lexer.l"
{ BEGIN EXPR; return IF; }
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 99 "lexer.l"
{ BEGIN INITIAL; return THEN; }
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 100 "lexer.l"
{ BEGIN INITIAL; return ';'; }
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 101 "lexer.l"
{ return OR; }
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 102 "lexer.l"
{ return AND; }
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 103 "lexer.l"
{ return NOT; }
	YY_BREAK
case 7:
#line 105 "lexer.l"
case 8:
#line 106 "lexer.l"
case 9:
#line 107 "lexer.l"
case 10:
#line 108 "lexer.l"
case 11:
#line 109 "lexer.l"
case 12:
#line 110 "lexer.l"
case 13:
#line 111 "lexer.l"
case 14:
#line 112 "lexer.l"
case 15:
#line 113 "lexer.l"
case 16:
#line 114 "lexer.l"
case 17:
#line 115 "lexer.l"
case 18:
YY_RULE_SETUP
#line 115 "lexer.l"
{ return yytext[0]; }
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 116 "lexer.l"
{ return CMP_EQ; }
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 117 "lexer.l"
{ return CMP_LE; }
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 118 "lexer.l"
{ return CMP_GE; }
	YY_BREAK
case 22:
#line 120 "lexer.l"
case 23:
YY_RULE_SETUP
#line 120 "lexer.l"
{ return CMP_NE; }
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 121 "lexer.l"
{ return CMP_LT; }
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 122 "lexer.l"
{ return CMP_GT; }
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 123 "lexer.l"
{ return CMP_CONTAINS; }
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 124 "lexer.l"
{ return CMP_CONTAINSI; }
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 125 "lexer.l"
{ return CMP_STARTSWITH; }
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 126 "lexer.l"
{ return CMP_STARTSWITHI; }
	YY_BREAK
case 30:
#line 128 "lexer.l"
case 31:
#line 129 "lexer.l"
case 32:
YY_RULE_SETUP
#line 129 "lexer.l"
{ yylval.n = strtoll(yytext, NULL, 0); return NUMBER; }
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 130 "lexer.l"
{ yylval.s = strdup(yytext); return VAR; }
	YY_BREAK
case 34:
/* rule 34 can match eol */
YY_RULE_SETUP
#line 131 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 35:
/* rule 35 can match eol */
YY_RULE_SETUP
#line 136 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 36:
/* rule 36 can match eol */
YY_RULE_SETUP
#line 141 "lexer.l"

	YY_BREAK
case 37:
YY_RULE_SETUP
#line 142 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return FUNC; }
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 144 "lexer.l"
{ parser_errmsg("invalid character '%s' in expression "
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case 39:
/* rule 39 can match eol */
YY_RULE_SETUP
#line 147 "lexer.l"

	YY_BREAK
case 40:
YY_RULE_SETUP
#line 148 "lexer.l"
{ parser_errmsg("invalid character '%s' in 'call' statement"
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 151 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  BEGIN INITIAL;
				  return NAME; }
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 154 "lexer.l"
{ return '&'; }
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 155 "lexer.l"
{ return '{'; }
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 156 "lexer.l"
{ return '}'; }
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 157 "lexer.l"
{ return STOP; }
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 158 "lexer.l"
{ return ELSE; }
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 159 "lexer.l"
{ BEGIN INCALL; return CALL; }
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 160 "lexer.l"
{ BEGIN EXPR; return SET; }
	YY_BREAK
case 49:
YY_RULE_SETUP
#line 161 "lexer.l"
{ BEGIN EXPR; return UNSET; }
	YY_BREAK
case 50:
YY_RULE_SETUP
#line 162 "lexer.l"
{ return CONTINUE; }
	YY_BREAK
/* line number support because the "preprocessor" combines lines and so needs
  * to tell us the real source line.
  */
case 51:
YY_RULE_SETUP
#line 166 "lexer.l"
{ BEGIN LINENO; }
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 167 "lexer.l"
{ yylineno = atoi(yytext) - 1; }
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 168 "lexer.l"
{ BEGIN INITIAL; }
	YY_BREAK
case 54:
/* rule 54 can match eol */
YY_RULE_SETUP
#line 169 "lexer.l"

	YY_BREAK
/* $IncludeConfig must be detected as part of CFSYSLINE, because this is
  * always the longest match :-(
  */
case 55:
/* rule 55 can match eol */
YY_RULE_SETUP
#line 173 "lexer.l"

	YY_BREAK
case 56:
YY_RULE_SETUP
#line 174 "lexer.l"
{ if(cnfDoInclude(yytext) != 0)
					yyterminate();
				  BEGIN INITIAL; }
	YY_BREAK
case 57:
/* rule 57 can match eol */
YY_RULE_SETUP
#line 177 "lexer.l"
{ yylval.objType = CNFOBJ_GLOBAL;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 58:
/* rule 58 can match eol */
YY_RULE_SETUP
#line 179 "lexer.l"
{ yylval.objType = CNFOBJ_TPL;
				  BEGIN INOBJ; return BEGIN_TPL; }
	YY_BREAK
case 59:
/* rule 59 can match eol */
YY_RULE_SETUP
#line 181 "lexer.l"
{ yylval.objType = CNFOBJ_RULESET;
				  BEGIN INOBJ; return BEGIN_RULESET; }
	YY_BREAK
case 60:
/* rule 60 can match eol */
YY_RULE_SETUP
#line 183 "lexer.l"
{ yylval.objType = CNFOBJ_PROPERTY;
				  BEGIN INOBJ; return BEGIN_PROPERTY; }
	YY_BREAK
case 61:
/* rule 61 can match eol */
YY_RULE_SETUP
#line 185 "lexer.l"
{ yylval.objType = CNFOBJ_CONSTANT;
				  BEGIN INOBJ; return BEGIN_CONSTANT; }
	YY_BREAK
case 62:
/* rule 62 can match eol */
YY_RULE_SETUP
#line 187 "lexer.l"
{ yylval.objType = CNFOBJ_INPUT;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 63:
/* rule 63 can match eol */
YY_RULE_SETUP
#line 189 "lexer.l"
{ yylval.objType = CNFOBJ_MODULE;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 64:
/* rule 64 can match eol */
YY_RULE_SETUP
#line 191 "lexer.l"
{ BEGIN INOBJ; return BEGIN_ACTION; }
	YY_BREAK
case 65:
/* rule 65 can match eol */
YY_RULE_SETUP
#line 192 "lexer.l"
{
				  yylval.s = strdup(rmLeadingSpace(yytext));
				  dbgprintf("lexer: propfilt is '%s'\n", yylval.s);
				  return PROPFILT;
				  }
	YY_BREAK
case 66:
YY_RULE_SETUP
#line 197 "lexer.l"
{ yylval.s = strdup(rmLeadingSpace(yytext)); return PRIFILT; }
	YY_BREAK
case 67:
#line 199 "lexer.l"
case 68:
#line 200 "lexer.l"
case 69:
/* rule 69 can match eol */
#line 201 "lexer.l"
case 70:
/* rule 70 can match eol */
#line 202 "lexer.l"
case 71:
/* rule 71 can match eol */
#line 203 "lexer.l"
case 72:
/* rule 72 can match eol */
#line 204 "lexer.l"
case 73:
/* rule 73 can match eol */
YY_RULE_SETUP
#line 204 "lexer.l"
{ yylval.s = yytext; return LEGACY_ACTION; }
	YY_BREAK
case 74:
YY_RULE_SETUP
#line 205 "lexer.l"
{ BEGIN INITIAL; return ENDOBJ; }
	YY_BREAK
case 75:
YY_RULE_SETUP
#line 206 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return NAME; }
	YY_BREAK
case 76:
#line 209 "lexer.l"
case 77:
#line 210 "lexer.l"
case 78:
#line 211 "lexer.l"
case 79:
YY_RULE_SETUP
#line 211 "lexer.l"
{ return(yytext[0]); }
	YY_BREAK
case 80:
/* rule 80 can match eol */
YY_RULE_SETUP
#line 212 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
/*yylval.estr = es_newStrFromBuf(yytext+1, yyleng-2);
				  return VALUE; }*/
case 81:
YY_RULE_SETUP
#line 219 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 82:
YY_RULE_SETUP
#line 220 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 83:
YY_RULE_SETUP
#line 221 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 84:
YY_RULE_SETUP
#line 222 "lexer.l"
{ BEGIN preCommentState; }
	YY_BREAK
case 85:
/* rule 85 can match eol */
YY_RULE_SETUP
#line 223 "lexer.l"

	YY_BREAK
case 86:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 224 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 87:
/* rule 87 can match eol */
YY_RULE_SETUP
#line 225 "lexer.l"

	YY_BREAK
case 88:
YY_RULE_SETUP
#line 226 "lexer.l"
{ parser_errmsg("invalid character '%s' in object definition "
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case 89:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 229 "lexer.l"
{ /* see comment on $IncludeConfig above */
				  if(!strncasecmp(yytext, "$includeconfig ", 14)) {
					yyless(14);
				  	BEGIN INCL;
				  } else if(!strncasecmp(yytext, "$ruleset ", 9)) {
					yylval.s = strdup(yytext);
					return LEGACY_RULESET;
				  } else {
					  cnfDoCfsysline(strdup(yytext)); 
				  }
				}
	YY_BREAK
case 90:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 240 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_TAG_SELECTOR; }
	YY_BREAK
case 91:
/* rule 91 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 241 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 92:
/* rule 92 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 242 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 93:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 243 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 94:
/* rule 94 can match eol */
YY_RULE_SETUP
#line 244 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 95:
/* rule 95 can match eol */
YY_RULE_SETUP
#line 245 "lexer.l"
/* drop whitespace */
	YY_BREAK
case 96:
YY_RULE_SETUP
#line 246 "lexer.l"
{ parser_errmsg("invalid character '%s' "
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(INOBJ):
case YY_STATE_EOF(COMMENT):
case YY_STATE_EOF(INCL):
case YY_STATE_EOF(LINENO):
case YY_STATE_EOF(INCALL):
case YY_STATE_EOF(EXPR):
#line 249 "lexer.l"
{ if(popfile() != 0) yyterminate(); }
	YY_BREAK
case 97:
YY_RULE_SETUP
#line 251 "lexer.l"
YY_FATAL_ERROR( "flex scanner jammed" );
	YY_BREAK
#line 2271 "lexer.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_c_buf_p);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap( ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	register char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	register char *source = (yytext_ptr);
	register int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr)) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc((void *) b->yy_ch_buf,b->yy_buf_size + 2  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), (size_t) num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart(yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((yy_size_t) ((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		yy_size_t new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	register yy_state_type yy_current_state;
	register char *yy_cp;
    
	yy_current_state = (yy_start);
	yy_current_state += YY_AT_BOL();

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 443 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	register int yy_is_jam;
    	register char *yy_cp = (yy_c_buf_p);

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 443 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 442);

	return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (yy_c_buf_p) - (yytext_ptr);
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart(yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap( ) )
						return EOF;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = (c == '\n');
	if ( YY_CURRENT_BUFFER_LVALUE->yy_at_bol )
		   
    yylineno++;
;

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer(yyin,YY_BUF_SIZE );
	}

	yy_init_buffer(YY_CURRENT_BUFFER,input_file );
	yy_load_buffer_state( );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state( );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void yy_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc(b->yy_buf_size + 2  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer(b,file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree((void *) b->yy_ch_buf  );

	yyfree((void *) b  );
}

#ifndef __cplusplus
extern int isatty (int );
#endif /* __cplusplus */
    
/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	yy_flush_buffer(b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state( );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state( );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void yypop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state( );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (void)
{
	int num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );
								  
		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer(b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (yyconst char * yystr )
{
    
	return yy_scan_bytes(yystr,strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (yyconst char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _yybytes_len + 2;
	buf = (char *) yyalloc(n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer(buf,n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yy_fatal_error (yyconst char* msg )
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
        
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
int yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/** Set the current line number.
 * @param line_number
 * 
 */
void yyset_lineno (int  line_number )
{
    
    yylineno = line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  in_str )
{
        yyin = in_str ;
}

void yyset_out (FILE *  out_str )
{
        yyout = out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  bdebug )
{
        yy_flex_debug = bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    /* We do not touch yylineno unless the option is enabled. */
    yylineno =  1;
    
    (yy_buffer_stack) = 0;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = (char *) 0;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = (FILE *) 0;
    yyout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer(YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n )
{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s )
{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
	return (void *) malloc( size );
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void yyfree (void * ptr )
{
	free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 251 "lexer.l"


int
cnfParseBuffer(char *buf, unsigned lenBuf)
{
	struct bufstack *bs;
	int r = 0;
	yydebug = 1;
	BEGIN INITIAL;
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup("*buffer*");
	bs->bs = yy_scan_buffer(buf,lenBuf);
	bs->estr = NULL;
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;
done:	return r;
}

/* set a new buffers. Returns 0 on success, something else otherwise. */
int
cnfSetLexFile(char *fname)
{
	es_str_t *str = NULL;
	FILE *fp;
	int r = 0;
	struct bufstack *bs;

	if(fname == NULL) {
		fp = stdin;
	} else {
		if((fp = fopen(fname, "r")) == NULL) {
			r = 1;
			goto done;
		}
	}
	readConfFile(fp, &str);
	if(fp != stdin)
		fclose(fp);
	
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup(fname == NULL ? "stdin" : fname);
	bs->bs = yy_scan_buffer((char*)es_getBufAddr(str),es_strlen(str));
	bs->estr = str; /* needed so we can free it later */
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;
	dbgprintf("config parser: pushed file %s on top of stack\n", fname);

done:
	if(r != 0) {
		if(str != NULL)
			es_deleteStr(str);
	}
	return r;
}


/* returns 0 on success, something else otherwise */
int
popfile(void)
{
	struct bufstack *bs = currbs;

	if(bs == NULL)
		return 1;
	
	/* delete current entry. But we must not free the file name if
	 * this is the top-level file, because then it may still be used
	 * in error messages for other processing steps.
	 * TODO: change this to another method which stores the file
	 * name inside the config objects. In the longer term, this is
	 * necessary, as otherwise we may provide wrong file name information
	 * at the end of include files as well. -- rgerhards, 2011-07-22
	 */
	dbgprintf("config parser: reached end of file %s\n", bs->fn);
	yy_delete_buffer(bs->bs);
	if(bs->prev != NULL)
		free(bs->fn);
	free(bs->estr);

	/* switch back to previous */
	currbs = bs->prev;
	free(bs);

	if(currbs == NULL) {
		dbgprintf("config parser: parsing completed\n");
		return 1; /* all processed */
	}
	
	yy_switch_to_buffer(currbs->bs);
	yylineno = currbs->lineno;
	cnfcurrfn = currbs->fn;
	dbgprintf("config parser: resume parsing of file %s at line %d\n",
		  cnfcurrfn, yylineno);
	return 0;
}

void
tellLexEndParsing(void)
{
	free(cnfcurrfn);
	cnfcurrfn= NULL;
}

